function gHUDOnLoad()
--Slash Commands	
	SLASH_gHUD_1 = "/groggy hud"
	SLASH_gHUD_2 = "/ghud"
	SlashCmdList["gHUD_"] = gHUD_Command
---------------------------------------------------------
--Handlers
	this:RegisterEvent("ADDON_LOADED")
	this:RegisterEvent("PLAYER_TARGET_CHANGED") 
	this:RegisterEvent("PARTY_MEMBERS_CHANGED")
	this:RegisterEvent("UNIT_PET")
	
	this:RegisterEvent("PLAYER_REGEN_DISABLED")
	this:RegisterEvent("PLAYER_REGEN_ENABLED")
	
	this.TimeSinceLastUpdate=0
end
--------------------------------------------------------
function TargetChangeOnEvent()
--show/hide target frames
---[[
	if (event=="PLAYER_TARGET_CHANGED") then
		--PartyFrameScale()
		if (UnitExists("target")) then
			HP_TARGET_FRAME:Show()
			
			HP_TARGET_BAR_TEXTURE:SetAlpha(Colors.hp100.a)
			HP_TARGET_BG_TEXTURE1:SetAlpha(Colors.hp100.a)
			HP_TARGET_BG_TEXTURE2:SetAlpha(Colors.hp100.a)
						
			MP_TARGET_BAR_TEXTURE:SetAlpha(Colors.mp100.a)
			MP_TARGET_BG_TEXTURE1:SetAlpha(Colors.mp100.a)
			MP_TARGET_BG_TEXTURE2:SetAlpha(Colors.mp100.a)
			
			if (UnitIsPlayer("target")==nil) 
			and (UnitPowerType("target")==1)  then
				MP_TARGET_FRAME:SetAlpha(0) 
			else
				MP_TARGET_FRAME:SetAlpha(Colors.mp100.a) 
			end
		end
	end
	--]]
end
---------------------------------------------------------
function PetChangeOnEvent()
--show/hide pet frames
	if (event=="UNIT_PET") then
		if (UnitExists("pet")) then
			HP_PET_FRAME:Show()
			MP_PET_FRAME:Show()
		else 
			HP_PET_FRAME:Hide()
			MP_PET_FRAME:Hide()
		end
	end
end
---------------------------------------------------------
function Load_HP_Player()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then
	--set position
		HP_PLAYER_FRAME:ClearAllPoints()
		HP_PLAYER_FRAME:SetPoint(Options.frame.invert.hppoint, nil, Options.frame.invert.hprelpoint, -Options.position.player.X, Options.position.player.Y)
	--texture
		HP_PLAYER_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
		HP_PLAYER_BG_TEXTURE1:SetHeight(Options.frame.bg.height)
		HP_PLAYER_BG_TEXTURE1:SetWidth(Options.frame.bg.width)
		HP_PLAYER_BG_TEXTURE2:SetHeight(Options.frame.bg.height-2)
		HP_PLAYER_BG_TEXTURE2:SetWidth(Options.frame.bg.width-2)
		
		HP_PLAYER_BAR:SetWidth(Options.frame.bar.width)
		HP_PLAYER_FRAME:SetHeight(Options.frame.bg.height)
		HP_PLAYER_FRAME:SetWidth(Options.frame.bg.width)
		
		HP_Player_Button:SetHeight(Options.frame.bg.height)
		HP_Player_Button:SetWidth(Options.frame.bg.width)
	--hp player max text
		HP_PLAYER_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		HP_PLAYER_MAX:SetTextColor(0, 1, 0, 1)
	--hp player percent text
		HP_PLAYER_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	--hp player deficit text
		HP_PLAYER_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	--hp player name text
		HP_PLAYER_NAME:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	end
end
---------------------------------------------------------
function Load_HP_Target()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then	
	--set position
		HP_TARGET_FRAME:ClearAllPoints()
		HP_TARGET_FRAME:SetPoint("BOTTOMLEFT", HP_PLAYER_FRAME, "BOTTOMRIGHT", Options.position.target.X, Options.position.target.Y)
	--texture
		HP_TARGET_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
		HP_TARGET_BG_TEXTURE1:SetHeight(Options.frame.bg.height)
		HP_TARGET_BG_TEXTURE1:SetWidth(Options.frame.bg.width)
		HP_TARGET_BG_TEXTURE2:SetHeight(Options.frame.bg.height-2)
		HP_TARGET_BG_TEXTURE2:SetWidth(Options.frame.bg.width-2)
		
		HP_TARGET_BAR:SetWidth(Options.frame.bar.width)
		HP_TARGET_FRAME:SetHeight(Options.frame.bg.height)
		HP_TARGET_FRAME:SetWidth(Options.frame.bg.width)
		
		HP_Target_Button:SetHeight(Options.frame.bg.height)
		HP_Target_Button:SetWidth(Options.frame.bg.width)
	--hp target max text
		HP_TARGET_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		HP_TARGET_MAX:SetTextColor(0, 1, 0, 1)
	--hp target percent text
		HP_TARGET_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	--hp target deficit text
		HP_TARGET_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	--hp target name text
		HP_TARGET_NAME:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	end
end
---------------------------------------------------------
function Load_HP_Party1()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then	
		if (Options.frame.active.party==1) then
		--set position
			HP_PARTY1_FRAME:ClearAllPoints()
			HP_PARTY1_FRAME:SetPoint("BOTTOMRIGHT", HP_PLAYER_FRAME, "BOTTOMLEFT", -Options.position.party.X, Options.position.party.Y)
		--texture
			PARTYPERCENT:Hide()
			HP_PARTY1_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
			
			HP_PARTY1_BG_TEXTURE1:SetWidth(Options.frame.bg.width)
			HP_PARTY1_BG_TEXTURE2:SetWidth(Options.frame.bg.width-2)
		
			HP_PARTY1_BAR:SetWidth(Options.frame.bar.width)
			HP_PARTY1_FRAME:SetWidth(Options.frame.bg.width)
			
			HP_Party1_Button:SetWidth(Options.frame.bg.width)
		--hp party1 deficit text
			HP_PARTY1_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party1 name text
			HP_PARTY1_NAME:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		end
	end
end
---------------------------------------------------------
function Load_HP_Party2()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then	
		if (Options.frame.active.party==1) then
		--texture
			HP_PARTY2_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
			
			HP_PARTY2_BG_TEXTURE1:SetWidth(Options.frame.bg.width)
			HP_PARTY2_BG_TEXTURE2:SetWidth(Options.frame.bg.width-2)
		
			HP_PARTY2_BAR:SetWidth(Options.frame.bar.width)
			HP_PARTY2_FRAME:SetWidth(Options.frame.bg.width)
			
			HP_Party2_Button:SetWidth(Options.frame.bg.width)
		--hp party2 deficit text
			HP_PARTY2_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party2 name text
			HP_PARTY2_NAME:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		end
	end
end
---------------------------------------------------------
function Load_HP_Party3()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then	
		if (Options.frame.active.party==1) then
		--texture
			HP_PARTY3_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
			
			HP_PARTY3_BG_TEXTURE1:SetWidth(Options.frame.bg.width)
			HP_PARTY3_BG_TEXTURE2:SetWidth(Options.frame.bg.width-2)
		
			HP_PARTY3_BAR:SetWidth(Options.frame.bar.width)
			HP_PARTY3_FRAME:SetWidth(Options.frame.bg.width)
			
			HP_Party3_Button:SetWidth(Options.frame.bg.width)
		--hp party3 deficit text
			HP_PARTY3_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party3 name text
			HP_PARTY3_NAME:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		end
	end
end
---------------------------------------------------------
function Load_HP_Party4()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then	
		if (Options.frame.active.party==1) then
		--texture
			HP_PARTY4_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
			
			HP_PARTY4_BG_TEXTURE1:SetWidth(Options.frame.bg.width)
			HP_PARTY4_BG_TEXTURE2:SetWidth(Options.frame.bg.width-2)
		
			HP_PARTY4_BAR:SetWidth(Options.frame.bar.width)
			HP_PARTY4_FRAME:SetWidth(Options.frame.bg.width)
			
			HP_Party4_Button:SetWidth(Options.frame.bg.width)
		--hp party4 deficit text
			HP_PARTY4_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party4 name text
			HP_PARTY4_NAME:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		end
	end
end
---------------------------------------------------------
function Load_HP_Pet()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then
		if (Options.frame.active.pet==1) then
		--set position
			HP_PET_FRAME:ClearAllPoints()
			HP_PET_FRAME:SetPoint("BOTTOMRIGHT", HP_PARTY1_FRAME, "BOTTOMLEFT", -Options.position.pet.X, Options.position.pet.Y)
		--texture
			HP_PET_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
			HP_PET_BG_TEXTURE1:SetHeight(Options.frame.bg.height/2)
			HP_PET_BG_TEXTURE1:SetWidth(Options.frame.bg.width)
			HP_PET_BG_TEXTURE2:SetHeight((Options.frame.bg.height/2)-2)
			HP_PET_BG_TEXTURE2:SetWidth(Options.frame.bg.width-2)
		
			HP_PET_BAR:SetWidth(Options.frame.bar.width)
			HP_PET_FRAME:SetHeight(Options.frame.bg.height/2)
			HP_PET_FRAME:SetWidth(Options.frame.bg.width)
			
			HP_Pet_Button:SetHeight(Options.frame.bg.height/2)
			HP_Pet_Button:SetWidth(Options.frame.bg.width)
		--hp pet max text
			HP_PET_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
			HP_PET_MAX:SetTextColor(0, 1, 0, 1)
		--hp pet percent text
			HP_PET_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp pet deficit text
			HP_PET_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp pet name text
			HP_PET_NAME:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		end
	end
end
---------------------------------------------------------
function Load_HP_TargetTarget()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then
		if (Options.frame.active.tt==1) then
		--set position
			HP_TARGETTARGET_FRAME:ClearAllPoints()
			HP_TARGETTARGET_FRAME:SetPoint("BOTTOMLEFT", HP_TARGET_FRAME, "BOTTOMRIGHT", Options.position.tt.X, Options.position.tt.Y)
		--texture
			HP_TARGETTARGET_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
			HP_TARGETTARGET_BG_TEXTURE1:SetHeight(Options.frame.bg.height/2)
			HP_TARGETTARGET_BG_TEXTURE1:SetWidth(Options.frame.bg.width)
			HP_TARGETTARGET_BG_TEXTURE2:SetHeight((Options.frame.bg.height/2)-2)
			HP_TARGETTARGET_BG_TEXTURE2:SetWidth(Options.frame.bg.width-2)
		
			HP_TARGETTARGET_BAR:SetWidth(Options.frame.bar.width)
			HP_TARGETTARGET_FRAME:SetHeight(Options.frame.bg.height/2)
			HP_TARGETTARGET_FRAME:SetWidth(Options.frame.bg.width)
		
			HP_TargetTarget_Button:SetHeight(Options.frame.bg.height/2)
			HP_TargetTarget_Button:SetWidth(Options.frame.bg.width)
		--hp targettarget max text
			HP_TARGETTARGET_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
			HP_TARGETTARGET_MAX:SetTextColor(0, 1, 0, 1)
		--hp targettarget percent text
			HP_TARGETTARGET_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp targettarget deficit text
			HP_TARGETTARGET_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp targettarget name text
			HP_TARGETTARGET_NAME:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		end
	end
end
------------------------------------------------------------------------------------------------------------------
function Load_MP_Player()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then
	--set position
		MP_PLAYER_FRAME:ClearAllPoints()
		MP_PLAYER_FRAME:SetPoint(Options.frame.invert.mppoint, nil, Options.frame.invert.mprelpoint, Options.position.player.X, Options.position.player.Y)
	--texture
		MP_PLAYER_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
		MP_PLAYER_BG_TEXTURE1:SetHeight(Options.frame.bg.height)
		MP_PLAYER_BG_TEXTURE1:SetWidth(Options.frame.bg.width)
		MP_PLAYER_BG_TEXTURE2:SetHeight(Options.frame.bg.height-2)
		MP_PLAYER_BG_TEXTURE2:SetWidth(Options.frame.bg.width-2)
		
		MP_PLAYER_BAR:SetWidth(Options.frame.bar.width)
		--MP_PLAYER_BAR:SetAlpha(Colors.mp100.a)
		
		MP_PLAYER_FRAME:SetHeight(Options.frame.bg.height)
		MP_PLAYER_FRAME:SetWidth(Options.frame.bg.width)
		
		MP_Player_Button:SetHeight(Options.frame.bg.height)
		MP_Player_Button:SetWidth(Options.frame.bg.width)
	--hp player max text
		MP_PLAYER_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		---[[
		if (UnitPowerType("player")==0) then
			MP_PLAYER_MAX:SetTextColor(0, 0, 1, 1)
		elseif (UnitPowerType("player")==1) then
			MP_PLAYER_MAX:SetTextColor(1, 0, 0, 1)
		elseif (UnitPowerType("player")==2) then
			MP_PLAYER_MAX:SetTextColor(1, 1, 0, 1)
		elseif (UnitPowerType("player")==3) then
			MP_PLAYER_MAX:SetTextColor(1, 1, 0, 1)
		end
		--]]
	--hp player percent text
		MP_PLAYER_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	--hp player deficit text
		MP_PLAYER_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	end
end
---------------------------------------------------------
function Load_MP_Target()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then	
	--set position
		MP_TARGET_FRAME:ClearAllPoints()
		MP_TARGET_FRAME:SetPoint("BOTTOMRIGHT", MP_PLAYER_FRAME, "BOTTOMLEFT", -Options.position.target.X, Options.position.target.Y)
	--texture
		MP_TARGET_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
		MP_TARGET_BG_TEXTURE1:SetHeight(Options.frame.bg.height)
		MP_TARGET_BG_TEXTURE1:SetWidth(Options.frame.bg.width)
		MP_TARGET_BG_TEXTURE2:SetHeight(Options.frame.bg.height-2)
		MP_TARGET_BG_TEXTURE2:SetWidth(Options.frame.bg.width-2)
		
		MP_TARGET_BAR:SetWidth(Options.frame.bar.width)
		MP_TARGET_FRAME:SetHeight(Options.frame.bg.height)
		MP_TARGET_FRAME:SetWidth(Options.frame.bg.width)
		
		MP_Target_Button:SetHeight(Options.frame.bg.height)
		MP_Target_Button:SetWidth(Options.frame.bg.width)
	--hp target max text
		MP_TARGET_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	--hp target percent text
		MP_TARGET_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	--hp target deficit text
		MP_TARGET_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	end
end
---------------------------------------------------------
function Load_MP_Party1()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then
		if (Options.frame.active.party==1) then
		--set position
			MP_PARTY1_FRAME:ClearAllPoints()
			MP_PARTY1_FRAME:SetPoint("BOTTOMLEFT", MP_PLAYER_FRAME, "BOTTOMRIGHT", Options.position.party.X, Options.position.party.Y)
		--texture
			MP_PARTY1_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
			
			MP_PARTY1_BG_TEXTURE1:SetWidth(Options.frame.bg.width)
			MP_PARTY1_BG_TEXTURE2:SetWidth(Options.frame.bg.width-2)
		
			MP_PARTY1_BAR:SetWidth(Options.frame.bar.width)
			MP_PARTY1_FRAME:SetWidth(Options.frame.bg.width)
		
			MP_Party1_Button:SetWidth(Options.frame.bg.width)
		--hp party1 deficit text
			MP_PARTY1_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		end
	end
end
---------------------------------------------------------
function Load_MP_Party2()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then
		if (Options.frame.active.party==1) then	
		--texture
			MP_PARTY2_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
			
			MP_PARTY2_BG_TEXTURE1:SetWidth(Options.frame.bg.width)
			MP_PARTY2_BG_TEXTURE2:SetWidth(Options.frame.bg.width-2)
		
			MP_PARTY2_BAR:SetWidth(Options.frame.bar.width)
			MP_PARTY2_FRAME:SetWidth(Options.frame.bg.width)
		
			MP_Party2_Button:SetWidth(Options.frame.bg.width)
		--hp party2 deficit text
			MP_PARTY2_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		end
	end
end
---------------------------------------------------------
function Load_MP_Party3()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then
		if (Options.frame.active.party==1) then
		--texture
			MP_PARTY3_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
			
			MP_PARTY3_BG_TEXTURE1:SetWidth(Options.frame.bg.width)
			MP_PARTY3_BG_TEXTURE2:SetWidth(Options.frame.bg.width-2)
		
			MP_PARTY3_BAR:SetWidth(Options.frame.bar.width)
			MP_PARTY3_FRAME:SetWidth(Options.frame.bg.width)
		
			MP_Party3_Button:SetWidth(Options.frame.bg.width)
		--hp party3 deficit text
			MP_PARTY3_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		end
	end
end
---------------------------------------------------------
function Load_MP_Party4()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then
		if (Options.frame.active.party==1) then	
		--texture
			MP_PARTY4_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
			
			MP_PARTY4_BG_TEXTURE1:SetWidth(Options.frame.bg.width)
			MP_PARTY4_BG_TEXTURE2:SetWidth(Options.frame.bg.width-2)
		
			MP_PARTY4_BAR:SetWidth(Options.frame.bar.width)
			MP_PARTY4_FRAME:SetWidth(Options.frame.bg.width)
		
			MP_Party4_Button:SetWidth(Options.frame.bg.width)
		--hp party4 deficit text
			MP_PARTY4_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		end
	end
end
---------------------------------------------------------
function Load_MP_Pet()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then
		if (Options.frame.active.pet==1) then
		--set position
			MP_PET_FRAME:ClearAllPoints()
			MP_PET_FRAME:SetPoint("BOTTOMLEFT", MP_PARTY1_FRAME, "BOTTOMRIGHT", Options.position.pet.X, Options.position.pet.Y)
		--texture
			MP_PET_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
			MP_PET_BG_TEXTURE1:SetHeight(Options.frame.bg.height/2)
			MP_PET_BG_TEXTURE1:SetWidth(Options.frame.bg.width)
			MP_PET_BG_TEXTURE2:SetHeight((Options.frame.bg.height/2)-2)
			MP_PET_BG_TEXTURE2:SetWidth(Options.frame.bg.width-2)
		
			MP_PET_BAR:SetWidth(Options.frame.bar.width)
			MP_PET_FRAME:SetHeight(Options.frame.bg.height/2)
			MP_PET_FRAME:SetWidth(Options.frame.bg.width)
		
			MP_Pet_Button:SetHeight(Options.frame.bg.height/2)
			MP_Pet_Button:SetWidth(Options.frame.bg.width)
		--hp pet max text
			MP_PET_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp pet percent text
			MP_PET_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp pet deficit text
			MP_PET_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		end
	end
end
---------------------------------------------------------
function Load_MP_TargetTarget()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then
		if (Options.frame.active.tt==1) then	
		--set position
			MP_TARGETTARGET_FRAME:ClearAllPoints()
			MP_TARGETTARGET_FRAME:SetPoint("BOTTOMRIGHT", MP_TARGET_FRAME, "BOTTOMLEFT", -Options.position.tt.X, Options.position.tt.Y)
		--texture
			MP_TARGETTARGET_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
			MP_TARGETTARGET_BG_TEXTURE1:SetHeight(Options.frame.bg.height/2)
			MP_TARGETTARGET_BG_TEXTURE1:SetWidth(Options.frame.bg.width)
			MP_TARGETTARGET_BG_TEXTURE2:SetHeight((Options.frame.bg.height/2)-2)
			MP_TARGETTARGET_BG_TEXTURE2:SetWidth(Options.frame.bg.width-2)
		
			MP_TARGETTARGET_BAR:SetWidth(Options.frame.bar.width)
			MP_TARGETTARGET_FRAME:SetHeight(Options.frame.bg.height/2)
			MP_TARGETTARGET_FRAME:SetWidth(Options.frame.bg.width)
			
			MP_TargetTarget_Button:SetHeight(Options.frame.bg.height/2)
			MP_TargetTarget_Button:SetWidth(Options.frame.bg.width)
		--hp targettarget max text
			MP_TARGETTARGET_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp targettarget percent text
			MP_TARGETTARGET_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp targettarget deficit text
			MP_TARGETTARGET_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		end
	end
end
------------------------------------------------------------------------------------------------
function HP_Player(arg1)
		unit = "player"
		tBar = HP_PLAYER_BAR_TEXTURE
		tBG  = HP_PLAYER_BG_TEXTURE1
		tBG2 = HP_PLAYER_BG_TEXTURE2
		fBut = HP_Player_Button
		fBar = HP_PLAYER_BAR
		fMax = HP_PLAYER_MAX
		fPer = HP_PLAYER_PERCENT
		fDef = HP_PLAYER_DEFICIT
		fNam = HP_PLAYER_NAME
	this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
	if (this.TimeSinceLastUpdate > Options.update) then	
	--Color
		HealthColor(unit,tBar,tBG,tBG2,fPer,fDef)
	--selected
		UnitSelected(unit,fBut)
	--Health
		local cur, max = UnitHealth(unit), UnitHealthMax(unit)
		local deficit = max-cur
	--hp bar
		if (cur==0) then
			fBar:SetHeight(1)
		else
			if (max>=cur) then
				fBar:SetHeight(Options.frame.bg.height/max*cur)
			else
				fBar:SetHeight(Options.frame.bg.height)
			end
		end
	--hp name text
		if (Options.name.player==1) then
			ClassColor(unit,fNam)
			fNam:SetText(string.sub(UnitName(unit), 1, Options.name.format.player)) 
		else
			fNam:SetText()
		end
	--hp max text
		if (not UnitInParty("party1")) then
			fMax:SetText(max)
		else 
			if (deficit==0) then
				fMax:SetText(max)
			elseif (deficit~=0) and (Options.frame.active.player==0) then
				fMax:SetText(max)
			elseif (deficit~=0) and (Options.frame.active.player==1) then
				fMax:SetText("-" ..deficit)
			elseif (deficit~=0) and (Options.frame.active.player==2) then
				fMax:SetText(cur)
			end
		end		
	--hp percent text
		fPer:SetText(string.format("%.0f", (100/max*cur)) .."%")
	--hp deficit text
		if (cur/max)>Options.deficit.player.Max
		or (cur/max)<Options.deficit.player.Min
		or UnitInParty("party1") and (Options.frame.active.party==1) then
			fDef:Hide() 
		else
			fDef:Show()
			if (Options.deficit.format==0) then
				fDef:SetText("-" ..deficit)
			elseif (Options.deficit.format==1) then		
				fDef:SetText(string.format("-%.1f", (deficit/1000)))
			end
		end
		this.TimeSinceLastUpdate=0
	end
end
---------------------------------------------------------
function HP_Target(arg1)
		unit = "target"
		tBar = HP_TARGET_BAR_TEXTURE
		tBG  = HP_TARGET_BG_TEXTURE1
		tBG2 = HP_TARGET_BG_TEXTURE2
		fBar = HP_TARGET_BAR
		fMax = HP_TARGET_MAX
		fPer = HP_TARGET_PERCENT
		fDef = HP_TARGET_DEFICIT
		fNam = HP_TARGET_NAME
	this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
	if (this.TimeSinceLastUpdate > Options.update) then
		if (UnitExists(unit)) then
		
		--Color
		HealthColor(unit,tBar,tBG,tBG2,fPer,fDef)
		--MobHealth
			local cur, max, found
			local deficit
			if MobHealth3 then
				cur, max, found = MobHealth3:GetUnitHealth(unit, UnitHealth(unit), UnitHealthMax(unit))
				deficit = max-cur
			else
				cur, max = UnitHealth(unit), UnitHealthMax(unit)
				deficit = max-cur
			end
		--targettarget	
			if (Options.frame.active.tt==1) 
			and (UnitExists("targettarget")) then
				if (not HP_TARGETTARGET_FRAME:GetAlpha(Colors.hp100.a)) then
					HP_TARGETTARGET_FRAME:SetAlpha(Colors.hp100.a) 
				end
			else 
				if (not HP_TARGETTARGET_FRAME:GetAlpha(0)) then
					HP_TARGETTARGET_FRAME:SetAlpha(0) 
				end
			end
		--hp target bar
			if (cur==0) then
				fBar:SetHeight(1)
			else
				if (max>=cur) then
					fBar:SetHeight(Options.frame.bg.height/max*cur)
				else
					fBar:SetHeight(Options.frame.bg.height)
				end
			end
		--hp name text
			if (Options.name.target==1) then
				ClassColor(unit,fNam)
				fNam:SetText(string.sub(UnitName(unit), 1, Options.name.format.target)) 
			else
				fNam:SetText()
			end
		--hp max text
			fMax:SetText(max)
		--hp percent text
			fPer:SetText(string.format("%.0f", (100/max*cur)) .."%")
		--hp deficit text
			if (cur/max)>Options.deficit.player.Max
			or (cur/max)<Options.deficit.player.Min then
				fDef:Hide() 
			else
				fDef:Show()
				if (Options.deficit.format==0) then
					fDef:SetText("-" ..deficit)
				elseif (Options.deficit.format==1) then		
					fDef:SetText(string.format("-%.1f", (deficit/1000)))
				end
			end
		end
		this.TimeSinceLastUpdate=0
	end
end
---------------------------------------------------------
function HP_Party1(arg1)	
			unit = "party1"
			tBar = HP_PARTY1_BAR_TEXTURE
			tBG  = HP_PARTY1_BG_TEXTURE1
			tBG2 = HP_PARTY1_BG_TEXTURE2
			fBut = HP_Party1_Button
			fBar = HP_PARTY1_BAR
			fBG	 = HP_PARTY1_FRAME
			fDef = HP_PARTY1_DEFICIT
			fNam = HP_PARTY1_NAME
			fPer = PARTYPERCENT
	if (Options.frame.active.party==1) then
		--enable frame
		fBG:SetAlpha(Colors.hp100.a)
		fBG:EnableMouse(true)
		fBut:EnableMouse(true)
		
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then
			if (UnitExists(unit)) then	
			--Color
				HealthColor(unit,tBar,tBG,tBG2,fPer,fDef)
			--selected
				UnitSelected(unit,fBut)
			--Health
			local cur, max = UnitHealth(unit), UnitHealthMax(unit)
			local deficit = max-cur
			--hp bar
			--if (InCombatLockdown()==nil) then
				PartyFrameScale(tBG,tBG2,fBG,fBut)
				PartyBarScale(fBar,max,cur)
			--else

			--end
			--hp name text
				HealthNameParty(unit,fNam)
			--hp deficit text
				HealthDeficitParty(cur,max,fDef,deficit)
			end
			this.TimeSinceLastUpdate=0
		end	
	else
		--disable frame
		DisableFrame(fBG,fBut)
	end
end
---------------------------------------------------------
function HP_Party2(arg1)
			unit = "party2"
			tBar = HP_PARTY2_BAR_TEXTURE
			tBG  = HP_PARTY2_BG_TEXTURE1
			tBG2 = HP_PARTY2_BG_TEXTURE2
			fBut = HP_Party2_Button
			fBar = HP_PARTY2_BAR
			fBG	 = HP_PARTY2_FRAME
			fDef = HP_PARTY2_DEFICIT
			fNam = HP_PARTY2_NAME
			fPer = PARTYPERCENT	
	if (Options.frame.active.party==1) then
		--enable frame
		fBG:SetAlpha(Colors.hp100.a)
		fBG:EnableMouse(true)
		fBut:EnableMouse(true)
		
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then
			if (UnitExists(unit)) then	
			--Color
				HealthColor(unit,tBar,tBG,tBG2,fPer,fDef)
			--selected
				UnitSelected(unit,fBut)
			--Health
			local cur, max = UnitHealth(unit), UnitHealthMax(unit)
			local deficit = max-cur
			--hp bar
				PartyFrameScale(tBG,tBG2,fBG,fBut)
				PartyBarScale(fBar,max,cur)
			--hp name text
				HealthNameParty(unit,fNam)
			--hp deficit text
				HealthDeficitParty(cur,max,fDef,deficit)
			end
			this.TimeSinceLastUpdate=0
		end	
	else
		--disable frame
		DisableFrame(fBG,fBut)
	end
end
---------------------------------------------------------
function HP_Party3(arg1)	
			unit = "party3"
			tBar = HP_PARTY3_BAR_TEXTURE
			tBG  = HP_PARTY3_BG_TEXTURE1
			tBG2 = HP_PARTY3_BG_TEXTURE2
			fBut = HP_Party3_Button
			fBar = HP_PARTY3_BAR
			fBG	 = HP_PARTY3_FRAME
			fDef = HP_PARTY3_DEFICIT
			fNam = HP_PARTY3_NAME
			fPer = PARTYPERCENT
	if (Options.frame.active.party==1) then
		--enable frame
		fBG:SetAlpha(Colors.hp100.a)
		fBG:EnableMouse(true)
		fBut:EnableMouse(true)
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then
			if (UnitExists(unit)) then	
			--Color
				HealthColor(unit,tBar,tBG,tBG2,fPer,fDef)
			--selected
				UnitSelected(unit,fBut)
			--Health
			local cur, max = UnitHealth(unit), UnitHealthMax(unit)
			local deficit = max-cur
			--hp bar
				PartyFrameScale(tBG,tBG2,fBG,fBut)
				PartyBarScale(fBar,max,cur)
			--hp name text
				HealthNameParty(unit,fNam)
			--hp deficit text
				HealthDeficitParty(cur,max,fDef,deficit)
			end
			this.TimeSinceLastUpdate=0
		end	
	else
		--disable frame
		DisableFrame(fBG,fBut)
	end
end
---------------------------------------------------------
function HP_Party4(arg1)
			unit = "party4"
			tBar = HP_PARTY4_BAR_TEXTURE
			tBG  = HP_PARTY4_BG_TEXTURE1
			tBG2 = HP_PARTY4_BG_TEXTURE2
			fBut = HP_Party4_Button
			fBar = HP_PARTY4_BAR
			fBG	 = HP_PARTY4_FRAME
			fDef = HP_PARTY4_DEFICIT
			fNam = HP_PARTY4_NAME
			fPer = PARTYPERCENT
	if (Options.frame.active.party==1) then
		--enable frame
		fBG:SetAlpha(Colors.hp100.a)
		fBG:EnableMouse(true)
		fBut:EnableMouse(true)
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then
			if (UnitExists(unit)) then	
			--Color
				HealthColor(unit,tBar,tBG,tBG2,fPer,fDef)
			--selected
				UnitSelected(unit,fBut)
			--Health
			local cur, max = UnitHealth(unit), UnitHealthMax(unit)
			local deficit = max-cur
			--hp bar
				PartyFrameScale(tBG,tBG2,fBG,fBut)
				PartyBarScale(fBar,max,cur)
			--hp name text
				HealthNameParty(unit,fNam)
			--hp deficit text
				HealthDeficitParty(cur,max,fDef,deficit)
			end
			this.TimeSinceLastUpdate=0
		end	
	else
		--disable frame
		DisableFrame(fBG,fBut)
	end
end
---------------------------------------------------------
function HP_Pet(arg1)
			unit = "pet"
			tBar = HP_PET_BAR_TEXTURE
			tBG  = HP_PET_BG_TEXTURE1
			tBG2 = HP_PET_BG_TEXTURE2
			fBut = HP_Pet_Button
			fBar = HP_PET_BAR
			fBG	 = HP_PET_FRAME	
			fMax = HP_PET_MAX
			fPer = HP_PET_PERCENT
			fDef = HP_PET_DEFICIT
			fNam = HP_PET_NAME
	if (Options.frame.active.pet==1) then
		--enable frame
		fBG:SetAlpha(Colors.hp100.a)
		fBG:EnableMouse(true)
		fBut:EnableMouse(true)
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then
			if (UnitExists(unit)) then	
			--Color
				HealthColor(unit,tBar,tBG,tBG2,fPer,fDef)
			--selected
				UnitSelected(unit,fBut)
			--Health
			local cur, max = UnitHealth(unit), UnitHealthMax(unit)
			local deficit = max-cur
			--hp bar
				if (cur==0) then
					fBar:SetHeight(1)
				else
					if (max>=cur) then
						fBar:SetHeight((Options.frame.bg.height/2)/max*cur)
					else
						fBar:SetHeight(Options.frame.bg.height/2)
					end
				end
			--hp name text
				if (Options.name.pet==1) then
					ClassColor(unit,fNam)
					fNam:SetText(string.sub(UnitName(unit), 1, Options.name.format.pet)) 
				else
					fNam:SetText()
				end
			--hp max text
				fMax:SetText(max)
			--hp percent text
				fPer:SetText(string.format("%.0f", (100/max*cur)) .."%")
			--hp deficit text
				if (cur/max)>Options.deficit.pet.Max
				or (cur/max)<Options.deficit.pet.Min then
					fDef:Hide() 
				else
					fDef:Show()
					if (Options.deficit.format==0) then
						fDef:SetText("-" ..deficit)
					elseif (Options.deficit.format==1) then		
						fDef:SetText(string.format("-%.1f", (deficit/1000)))
					end
				end
			end
			this.TimeSinceLastUpdate=0
		end
	else
		--disable frame
		DisableFrame(fBG,fBut)
	end
end
---------------------------------------------------------
function HP_TargetTarget(arg1)
			unit = "targettarget"
			tBar = HP_TARGETTARGET_BAR_TEXTURE
			tBG  = HP_TARGETTARGET_BG_TEXTURE1
			tBG2 = HP_TARGETTARGET_BG_TEXTURE2
			fBut = HP_TargetTarget_Button
			fBar = HP_TARGETTARGET_BAR
			fBG	 = HP_TARGETTARGET_FRAME	
			fMax = HP_TARGETTARGET_MAX
			fPer = HP_TARGETTARGET_PERCENT
			fDef = HP_TARGETTARGET_DEFICIT
			fNam = HP_TARGETTARGET_NAME
	if (Options.frame.active.tt==1) then
		--enable frame
		fBG:SetAlpha(Colors.hp100.a)
		fBG:EnableMouse(true)
		fBut:EnableMouse(true)
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then
			if (UnitExists(unit)) then
			--Color
				HealthColor(unit,tBar,tBG,tBG2,fPer,fDef)
			--selected
				UnitSelected(unit,fBut)
			--MobHealth
				local cur, max, found
				local deficit
				if MobHealth3 then
					cur, max, found = MobHealth3:GetUnitHealth(unit, UnitHealth(unit), UnitHealthMax(unit))
					deficit = max-cur
				else
					cur, max = UnitHealth(unit), UnitHealthMax(unit)
					deficit = max-cur
				end
			--hp bar
				if (cur==0) then
					fBar:SetHeight(1)
				else
					if (max>=cur) then
						fBar:SetHeight((Options.frame.bg.height/2)/max*cur)
					else
						fBar:SetHeight(Options.frame.bg.height/2)
					end
				end
			--hp name text
				if (Options.name.tt==1) then
					ClassColor(unit,fNam)	
					fNam:SetText(string.sub(UnitName(unit), 1, Options.name.format.tt)) 
				else
					fNam:SetText()
				end
			--hp max text
				fMax:SetText(max)
			--hp percent text
				fPer:SetText(string.format("%.0f", (100/max*cur)) .."%")
			--hp deficit text
				if (cur/max)>Options.deficit.tt.Max
				or (cur/max)<Options.deficit.tt.Min then
					fDef:Hide() 
				else
					fDef:Show()
					if (Options.deficit.format==0) then
						fDef:SetText("-" ..deficit)
					elseif (Options.deficit.format==1) then		
						fDef:SetText(string.format("-%.1f", (deficit/1000)))
					end
				end
			end
			this.TimeSinceLastUpdate=0
		end
	else
		--disable frame
		DisableFrame(fBG,fBut)
	end
end
------------------------------------------------------------------------------------------------------------------
function MP_Player(arg1)
		unit = "player"
		tBar = MP_PLAYER_BAR_TEXTURE
		tBG  = MP_PLAYER_BG_TEXTURE1
		tBG2 = MP_PLAYER_BG_TEXTURE2
		fBar = MP_PLAYER_BAR
		fMax = MP_PLAYER_MAX
		fPer = MP_PLAYER_PERCENT
		fDef = MP_PLAYER_DEFICIT
	this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
	if (this.TimeSinceLastUpdate > Options.update) then	
	--Color
		ManaColor(unit,tBar,tBG,tBG2,fPer,fDef)
	--Health
		local cur, max = UnitMana(unit), UnitManaMax(unit)
		local deficit = max-cur
	--mp bar
		if (cur==0) then
			fBar:SetHeight(1)
		else
			if (max>=cur) then
				fBar:SetHeight(Options.frame.bg.height/max*cur)
			else
				fBar:SetHeight(Options.frame.bg.height)
			end
		end
	--mp max text
		if (not UnitInParty("party1")) then
			fMax:SetText(max)
			--DEFAULT_CHAT_FRAME:AddMessage(max)
		else 
			if (deficit==0) then
				fMax:SetText(max)
			elseif (deficit~=0) and (Options.frame.active.player==0) then
				fMax:SetText(max)
			elseif (deficit~=0) and (Options.frame.active.player==1) then
				fMax:SetText("-" ..deficit)
			elseif (deficit~=0) and (Options.frame.active.player==2) then
				fMax:SetText(cur)
			end
		end
	--mp percent text
		fPer:SetText(string.format("%.0f", (100/max*cur)) .."%")
	--mp deficit text
		if (cur/max)>Options.deficit.player.Max
		or (cur/max)<Options.deficit.player.Min
		or UnitInParty("party1") and (Options.frame.active.party==1) then 
			fDef:Hide()
		else
			if (UnitPowerType(unit)==0) then
				fDef:Show()
				if (Options.deficit.format==0) then
					fDef:SetText("-" ..deficit)
				elseif 	(Options.deficit.format==1) then
					fDef:SetText(string.format("-%.1f", (deficit/1000)))
				end
			elseif (UnitPowerType(unit)==1)
				or (UnitPowerType(unit)==2)
				or (UnitPowerType(unit)==3) then
					fDef:Show()
					fDef:SetText(cur)
			end
		end
		this.TimeSinceLastUpdate=0
	end
end
---------------------------------------------------------
function MP_Target(arg1)
		unit = "target"
		tBar = MP_TARGET_BAR_TEXTURE
		tBG  = MP_TARGET_BG_TEXTURE1
		tBG2 = MP_TARGET_BG_TEXTURE2
		fBar = MP_TARGET_BAR
		fMax = MP_TARGET_MAX
		fPer = MP_TARGET_PERCENT
		fDef = MP_TARGET_DEFICIT
	this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
	if (this.TimeSinceLastUpdate > Options.update) then	
		if (UnitExists(unit)) then	
	--Color
		ManaColor(unit,tBar,tBG,tBG2,fPer,fDef)
	--Health
		local cur, max = UnitMana(unit), UnitManaMax(unit)
		local deficit = max-cur
			
			if (Options.frame.active.tt==1)
			and (UnitExists("targettarget")) then			
				if (UnitIsPlayer("targettarget")==nil) 
				and (UnitPowerType("targettarget")==1) then
					MP_TARGETTARGET_FRAME:SetAlpha(0) 
				else
					if (not MP_TARGETTARGET_FRAME:GetAlpha(Colors.mp100.a)) then
						MP_TARGETTARGET_FRAME:SetAlpha(Colors.mp100.a) 
					end
				end
			else 
				if (not MP_TARGETTARGET_FRAME:GetAlpha(0)) then
					MP_TARGETTARGET_FRAME:SetAlpha(0)
				end
			end	
		--mp bar
			if (cur==0) then
				fBar:SetHeight(1)
			else
				if (max>=cur) then
					fBar:SetHeight(Options.frame.bg.height/max*cur)
				else
					fBar:SetHeight(Options.frame.bg.height)
				end
			end
		--mp max text
			fMax:SetText(max)
			if (UnitPowerType(unit)==0) then
				fMax:SetTextColor(0, 0, 1, 1)
			elseif (UnitPowerType(unit)==1) then
				fMax:SetTextColor(1, 0, 0, 1)
			elseif (UnitPowerType(unit)==2) then
				fMax:SetTextColor(1, 1, 0, 1)
			elseif (UnitPowerType(unit)==3) then
				fMax:SetTextColor(1, 1, 0, 1)
			end
		--mp percent text
			fPer:SetText(string.format("%.0f", (100/max*cur)) .."%")
		--mp deficit text
			if (cur/max)>Options.deficit.player.Max
			or (cur/max)<Options.deficit.player.Min then 
				MP_TARGET_DEFICIT:Hide()
			else
				if (UnitPowerType(unit)==0) then
					fDef:Show()
					if (Options.deficit.format==0) then
						fDef:SetText("-" ..deficit)
					elseif (Options.deficit.format==1) then	
						fDef:SetText(string.format("-%.1f", (deficit/1000)))
					end
				elseif (UnitPowerType(unit)==1)
					or (UnitPowerType(unit)==2)
					or (UnitPowerType(unit)==3) then
						fDef:Show()
						fDef:SetText(cur)
				end
			end
		end
		this.TimeSinceLastUpdate=0
	end
end
---------------------------------------------------------
function MP_Party1(arg1)	
			unit = "party1"
			tBar = MP_PARTY1_BAR_TEXTURE
			tBG  = MP_PARTY1_BG_TEXTURE1
			tBG2 = MP_PARTY1_BG_TEXTURE2
			fBut = MP_Party1_Button
			fBar = MP_PARTY1_BAR
			fBG	 = MP_PARTY1_FRAME
			fDef = MP_PARTY1_DEFICIT
			fPer = PARTYPERCENT
	if (Options.frame.active.party==1) then
		--enable frame
		fBG:SetAlpha(Colors.mp100.a)
		fBG:EnableMouse(true)
		fBut:EnableMouse(true)
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then	
			if (UnitExists(unit)) then
		--Color
			ManaColor(unit,tBar,tBG,tBG2,fPer,fDef)
		--Health
			local cur, max = UnitMana(unit), UnitManaMax(unit)
			local deficit = max-cur
			--mp bar
				PartyFrameScale(tBG,tBG2,fBG,fBut)
				PartyBarScale(fBar,max,cur)
			--mp deficit text
				ManaDeficitParty(unit,cur,max,fDef,deficit)
			end
			this.TimeSinceLastUpdate=0
		end
	else
		--disable frame
		DisableFrame(fBG,fBut)
	end
end
---------------------------------------------------------
function MP_Party2(arg1)
			unit = "party2"
			tBar = MP_PARTY2_BAR_TEXTURE
			tBG  = MP_PARTY2_BG_TEXTURE1
			tBG2 = MP_PARTY2_BG_TEXTURE2
			fBut = MP_Party2_Button
			fBar = MP_PARTY2_BAR
			fBG	 = MP_PARTY2_FRAME
			fDef = MP_PARTY2_DEFICIT
			fPer = PARTYPERCENT
	if (Options.frame.active.party==1) then
		--enable frame
		fBG:SetAlpha(Colors.mp100.a)
		fBG:EnableMouse(true)
		fBut:EnableMouse(true)
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then	
			if (UnitExists(unit)) then
		--Color
			ManaColor(unit,tBar,tBG,tBG2,fPer,fDef)
		--Health
			local cur, max = UnitMana(unit), UnitManaMax(unit)
			local deficit = max-cur
			--mp bar
				PartyFrameScale(tBG,tBG2,fBG,fBut)
				PartyBarScale(fBar,max,cur)
			--mp deficit text
				ManaDeficitParty(unit,cur,max,fDef,deficit)
			end
			this.TimeSinceLastUpdate=0
		end
	else
		--disable frame
		DisableFrame(fBG,fBut)
	end
end
---------------------------------------------------------
function MP_Party3(arg1)
			unit = "party3"
			tBar = MP_PARTY3_BAR_TEXTURE
			tBG  = MP_PARTY3_BG_TEXTURE1
			tBG2 = MP_PARTY3_BG_TEXTURE2
			fBut = MP_Party3_Button
			fBar = MP_PARTY3_BAR
			fBG	 = MP_PARTY3_FRAME
			fDef = MP_PARTY3_DEFICIT
			fPer = PARTYPERCENT
	if (Options.frame.active.party==1) then
		--enable frame
		fBG:SetAlpha(Colors.mp100.a)
		fBG:EnableMouse(true)
		fBut:EnableMouse(true)
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then	
			if (UnitExists(unit)) then
		--Color
			ManaColor(unit,tBar,tBG,tBG2,fPer,fDef)
		--Health
			local cur, max = UnitMana(unit), UnitManaMax(unit)
			local deficit = max-cur
			--mp bar
				PartyFrameScale(tBG,tBG2,fBG,fBut)
				PartyBarScale(fBar,max,cur)
			--mp deficit text
				ManaDeficitParty(unit,cur,max,fDef,deficit)
			end
			this.TimeSinceLastUpdate=0
		end
	else
		--disable frame
		DisableFrame(fBG,fBut)
	end
end
---------------------------------------------------------
function MP_Party4(arg1)
			unit = "party4"
			tBar = MP_PARTY4_BAR_TEXTURE
			tBG  = MP_PARTY4_BG_TEXTURE1
			tBG2 = MP_PARTY4_BG_TEXTURE2
			fBut = MP_Party4_Button
			fBar = MP_PARTY4_BAR
			fBG	 = MP_PARTY4_FRAME
			fDef = MP_PARTY4_DEFICIT
			fPer = PARTYPERCENT
	if (Options.frame.active.party==1) then
		--enable frame
		fBG:SetAlpha(Colors.mp100.a)
		fBG:EnableMouse(true)
		fBut:EnableMouse(true)
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then	
			if (UnitExists(unit)) then
		--Color
			ManaColor(unit,tBar,tBG,tBG2,fPer,fDef)
		--Health
			local cur, max = UnitMana(unit), UnitManaMax(unit)
			local deficit = max-cur
			--mp bar
				PartyFrameScale(tBG,tBG2,fBG,fBut)
				PartyBarScale(fBar,max,cur)
			--mp deficit text
				ManaDeficitParty(unit,cur,max,fDef,deficit)
			end
			this.TimeSinceLastUpdate=0
		end
	else
		--disable frame
		DisableFrame(fBG,fBut)
	end
end
---------------------------------------------------------
function MP_Pet(arg1)
			unit = "pet"
			tBar = MP_PET_BAR_TEXTURE
			tBG  = MP_PET_BG_TEXTURE1	
			tBG2 = MP_PET_BG_TEXTURE2
			fBut = MP_Pet_Button
			fBar = MP_PET_BAR
			fBG	 = MP_PET_FRAME	
			fMax = MP_PET_MAX
			fPer = MP_PET_PERCENT
			fDef = MP_PET_DEFICIT
	if (Options.frame.active.pet==1) then
		--enable frame
		fBG:SetAlpha(Colors.mp100.a)
		fBG:EnableMouse(true)
		fBut:EnableMouse(true)
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then	
			if (UnitExists(unit)) then	
			--Color
				ManaColor(unit,tBar,tBG,tBG2,fPer,fDef)
			--Health
			local cur, max = UnitMana(unit), UnitManaMax(unit)
			local deficit = max-cur	
			--mp bar
				if (cur==0) then
					fBar:SetHeight(1)
				else
					if (max>=cur) then
						fBar:SetHeight((Options.frame.bg.height/2)/max*cur)
					else
						fBar:SetHeight(Options.frame.bg.height/2)
					end
				end
			--mp max text
				fMax:SetText(max)
				if (UnitPowerType(unit)==0) then
					fMax:SetTextColor(0, 0, 1, 1)
				elseif (UnitPowerType(unit)==1) then
					fMax:SetTextColor(1, 0, 0, 1)
				elseif (UnitPowerType(unit)==2) then
					fMax:SetTextColor(1, 1, 0, 1)
				elseif (UnitPowerType(unit)==3) then
					fMax:SetTextColor(1, 1, 0, 1)
				end
			--mp percent text
				fPer:SetText(string.format("%.0f", (100/max*cur)) .."%")
			--mp deficit text
				if (cur/max)>Options.deficit.pet.Max
				or (cur/max)<Options.deficit.pet.Min then 
					fDef:Hide()
				else
					if (UnitPowerType(unit)==0) then
						fDef:Show()
						if (Options.deficit.format==0) then
							fDef:SetText("-" ..deficit)
						elseif (Options.deficit.format==1) then		
							fDef:SetText(string.format("-%.1f", (deficit/1000)))
						end
					elseif (UnitPowerType(unit)==1)
						or (UnitPowerType(unit)==2)
						or (UnitPowerType(unit)==3) then
							fDef:Show()
							fDef:SetText(cur)
					end
				end
			end
			this.TimeSinceLastUpdate=0
		end
	else
		--disable frame
		DisableFrame(fBG,fBut)
	end
end
---------------------------------------------------------
function MP_TargetTarget(arg1)
			unit = "targettarget"
			tBar = MP_TARGETTARGET_BAR_TEXTURE
			tBG  = MP_TARGETTARGET_BG_TEXTURE1
			tBG2 = MP_TARGETTARGET_BG_TEXTURE2	
			fBut = MP_TargetTarget_Button
			fBar = MP_TARGETTARGET_BAR
			fBG	 = MP_TARGETTARGET_FRAME	
			fMax = MP_TARGETTARGET_MAX
			fPer = MP_TARGETTARGET_PERCENT
			fDef = MP_TARGETTARGET_DEFICIT
	if (Options.frame.active.tt==1) then
		--enable frame
		fBG:SetAlpha(Colors.mp100.a)
		fBG:EnableMouse(true)
		fBut:EnableMouse(true)
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then	
			if (UnitExists(unit)) then
			--Color
				ManaColor(unit,tBar,tBG,tBG2,fPer,fDef)
			--Health
			local cur, max = UnitMana(unit), UnitManaMax(unit)
			local deficit = max-cur	
			--mp bar
				if (cur==0) then
					fBar:SetHeight(1)
				else
					if (max>=cur) then
						fBar:SetHeight((Options.frame.bg.height/2)/max*cur)
					else
						fBar:SetHeight(Options.frame.bg.height/2)
					end
				end
			--mp max text
				fMax:SetText(max)
				if (UnitPowerType(unit)==0) then
					fMax:SetTextColor(0, 0, 1, 1)
				elseif (UnitPowerType(unit)==1) then
					fMax:SetTextColor(1, 0, 0, 1)
				elseif (UnitPowerType(unit)==2) then
					fMax:SetTextColor(1, 1, 0, 1)
				elseif (UnitPowerType(unit)==3) then
					fMax:SetTextColor(1, 1, 0, 1)
				end
			--mp percent text
				fPer:SetText(string.format("%.0f", (100/max*cur)) .."%")
			--mp deficit text
				if (cur/max)>Options.deficit.tt.Max
				or (cur/max)<Options.deficit.tt.Min then 
					fDef:Hide()
				else
					if (UnitPowerType(unit)==0) then
						fDef:Show()
						if (Options.deficit.format==0) then
							fDef:SetText("-" ..deficit)
						elseif (Options.deficit.format==1) then		
							fDef:SetText(string.format("-%.1f", (deficit/1000)))
						end
					elseif (UnitPowerType(unit)==1)
						or (UnitPowerType(unit)==2)
						or (UnitPowerType(unit)==3) then
							fDef:Show()
							fDef:SetText(cur)
					end
				end
			end
			this.TimeSinceLastUpdate=0
		end
	else
		--disable frame
		DisableFrame(fBG,fBut)
	end
end
------------------------------------------------------------------------------------------------------------------
function HealthColor(unit,tBar,tBG,tBG2,fPer,fDef)
	local deficit = (1-(UnitHealth(unit)/UnitHealthMax(unit)))
	-- grey frame for those conditions
	if (UnitIsTapped(unit)) and (not UnitIsTappedByPlayer(unit))
	or (UnitIsTrivial(unit))
	or (UnitIsDeadOrGhost(unit))
	or (not UnitIsConnected(unit)) then
		local r,g,b,a = 0.5, 0.5, 0.5, Colors.hp100.a
		if (Options.fade.active==1) then
			FrameStopFlashing(tBar,tBG)
			ShowAfterFlash(tBar,tBG,tBG2)
			ColorFadeFrames(r,g,b)
			FrameFade(unit,deficit,a,tBar,tBG,tBG2)
		else 
			FrameStopFlashing(tBar,tBG)
			ColorFrames(r,g,b,a)
		end
	else
		--100
		if (deficit == 0) then 
			local r,g,b,a = Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a
			if (Options.fade.active==1) then
				FrameStopFlashing(tBar,tBG)
				ShowAfterFlash(tBar,tBG,tBG2)
				ColorFadeFrames(r,g,b)
				FrameFade(unit,deficit,a,tBar,tBG,tBG2)
			else 
				FrameStopFlashing(tBar,tBG)
				ColorFrames(r,g,b,a)
			end
		--  > 0 < 0.5
		elseif (deficit > 0) and (deficit < 0.5) then 
			local r,g,b,a = deficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a
			if (Options.fade.active==1) then
				FrameStopFlashing(tBar,tBG)
				ShowAfterFlash(tBar,tBG,tBG2)
				ColorFadeFrames(r,g,b)
				FrameFade(unit,deficit,a,tBar,tBG,tBG2)
			else 
				FrameStopFlashing(tBar,tBG)
				ColorFrames(r,g,b,a)
			end
		-- >0.5 < 0.8
		elseif (deficit > 0.5) and (deficit < 0.8) then
			local r,g,b,a = Colors.hp50.r, (1-deficit)*2, Colors.hp50.b, Colors.hp50.a
			if (Options.fade.active==1) then
				FrameStopFlashing(tBar,tBG)
				ShowAfterFlash(tBar,tBG,tBG2)
				ColorFadeFrames(r,g,b)
				FrameFade(unit,deficit,a,tBar,tBG,tBG2)
			else 
				FrameStopFlashing(tBar,tBG)
				ColorFrames(r,g,b,a)
			end
		-- 20-
		elseif (deficit == 0.8) or (deficit > 0.8) then 
			local r,g,b = Colors.hp20.r, Colors.hp20.g, Colors.hp20.b
			if (Options.flash.Bar==1) or (Options.flash.BG==1) then
				ColorFadeFrames(r,g,b)
			else
				ColorFrames(r,g,b,a)
			end
			--startflashing
			if (Options.flash.Bar==1) then
				UIFrameFlash(tBar, Options.flash.In, Options.flash.Out, (Options.flash.In + Options.flash.Out + Options.flash.InHold + Options.flash.OutHold), false, Options.flash.OutHold, Options.flash.InHold)
			end
			if (Options.flash.BG==1) then
				UIFrameFlash(tBG, Options.flash.In, Options.flash.Out, (Options.flash.In + Options.flash.Out + Options.flash.InHold + Options.flash.OutHold), false, Options.flash.OutHold, Options.flash.InHold)
			end	
		end
	end
end
---------------------------------------------------------
function ManaColor(unit,tBar,tBG,tBG2,fPer,fDef)
	local deficit = (1-(UnitMana(unit)/UnitManaMax(unit)))
	
	--powertype mana
	if (UnitPowerType(unit)==0) then 
		-- grey frame for those conditions
		if (UnitIsTapped(unit)) and (not UnitIsTappedByPlayer(unit))
		or (UnitIsTrivial(unit))
		or (UnitIsDeadOrGhost(unit))
		or (not UnitIsConnected(unit)) then
			local r,g,b,a = 0.5, 0.5, 0.5, Colors.mp100.a
			--fade in
			if (Options.fade.active==1) then
				FrameStopFlashing(tBar,tBG)
				ShowAfterFlash(tBar,tBG,tBG2)
				ColorFadeFrames(r,g,b)
				FrameFade(unit,deficit,a,tBar,tBG,tBG2)
			else 
				FrameStopFlashing(tBar,tBG)
				ColorFrames(r,g,b,a)
			end
		else
			--100
			if (deficit == 0) then				
			local r,g,b,a = Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a
				if (Options.fade.active==1) then
					FrameStopFlashing(tBar,tBG)
					ShowAfterFlash(tBar,tBG,tBG2)
					ColorFadeFrames(r,g,b)
					FrameFade(unit,deficit,a,tBar,tBG,tBG2)
				else 
					FrameStopFlashing(tBar,tBG)
					ColorFrames(r,g,b,a)
				end
			--  > 0 < 0.5
			elseif ((deficit > 0) and (deficit < 0.5)) then
				local r,g,b,a = deficit*2, deficit*2, Colors.mp100.b, Colors.mp100.a
				if (Options.fade.active==1) then
					FrameStopFlashing(tBar,tBG)
					ShowAfterFlash(tBar,tBG,tBG2)
					ColorFadeFrames(r,g,b)
					FrameFade(unit,deficit,a,tBar,tBG,tBG2)
				else 
					FrameStopFlashing(tBar,tBG)
					ColorFrames(r,g,b,a)
				end
			-- >0.5 < 0.8
			elseif (deficit > 0.5) and (deficit < 0.8) then
				local r,g,b,a = Colors.mp50.r, (1-deficit)*2, (1-deficit)*2, Colors.mp50.a
				--fade in
				if (Options.fade.active==1) then
					FrameStopFlashing(tBar,tBG)
					ShowAfterFlash(tBar,tBG,tBG2)
					ColorFadeFrames(r,g,b)
					FrameFade(unit,deficit,a,tBar,tBG,tBG2)
				else 
					FrameStopFlashing(tBar,tBG)
					ColorFrames(r,g,b,a)
				end
			-- 20-
			elseif (deficit == 0.8) or (deficit > 0.8) then
				local r,g,b = Colors.mp20.r, Colors.mp20.g, Colors.mp20.b
				if (Options.flash.Bar==1) or (Options.flash.BG==1) then
					ColorFadeFrames(r,g,b)
				else
					ColorFrames(r,g,b,a)
				end
			--startflashing
				if (Options.flash.Bar==1) then
					UIFrameFlash(tBar, Options.flash.In, Options.flash.Out, (Options.flash.In + Options.flash.Out + Options.flash.InHold + Options.flash.OutHold), false, Options.flash.OutHold, Options.flash.InHold)
				end
				if (Options.flash.BG==1) then
					UIFrameFlash(tBG, Options.flash.In, Options.flash.Out, (Options.flash.In + Options.flash.Out + Options.flash.InHold + Options.flash.OutHold), false, Options.flash.OutHold, Options.flash.InHold)
				end
			end
		end
	--powertype rage
	elseif (UnitPowerType(unit)==1) then 
		-- grey frame for those conditions
		if (UnitIsTapped(unit)) and (not UnitIsTappedByPlayer(unit))
		or (UnitIsTrivial(unit))
		or (UnitIsDeadOrGhost(unit))
		or (not UnitIsConnected(unit)) then
			local r,g,b,a = 0.5, 0.5, 0.5, Colors.mp100.a
			if (Options.fade.active==1) then
				FrameStopFlashing(tBar,tBG)
				ShowAfterFlash(tBar,tBG,tBG2)
				ColorFadeFrames(r,g,b)
				FrameFade(unit,deficit,a,tBar,tBG,tBG2)
			else 
				ColorFrames(r,g,b,a)
				FrameStopFlashing(tBar,tBG)
			end
		else
			local r,g,b,a = 1, 0, 0, Colors.mp100.a
			if (Options.fade.active==1) then
				FrameStopFlashing(tBar,tBG)
				ShowAfterFlash(tBar,tBG,tBG2)
				ColorFadeFrames(r,g,b)
				FrameFade(unit,deficit,a,tBar,tBG,tBG2)
			else 
				FrameStopFlashing(tBar,tBG)
				ColorFrames(r,g,b,a)
			end
		end
	--powertype focus/energy
	elseif (UnitPowerType(unit)==2) or (UnitPowerType(unit)==3) then -- grey frame for those conditions
		if (UnitIsTapped(unit)) and (not UnitIsTappedByPlayer(unit))
		or (UnitIsTrivial(unit))
		or (UnitIsDeadOrGhost(unit))
		or (not UnitIsConnected(unit)) then
			local r,g,b,a = 0.5, 0.5, 0.5, Colors.mp100.a
			if (Options.fade.active==1) then
				FrameStopFlashing(tBar,tBG)
				ShowAfterFlash(tBar,tBG,tBG2)
				ColorFadeFrames(r,g,b)
				FrameFade(unit,deficit,a,tBar,tBG,tBG2)
			else 
				FrameStopFlashing(tBar,tBG)
				ColorFrames(r,g,b,a)
			end
		else
			local r,g,b,a = 1, 1, 0, Colors.mp100.a
			if (Options.fade.active==1) then
				FrameStopFlashing(tBar,tBG)
				ShowAfterFlash(tBar,tBG,tBG2)
				ColorFadeFrames(r,g,b)
				FrameFade(unit,deficit,a,tBar,tBG,tBG2)
			else 
				FrameStopFlashing(tBar,tBG)
				ColorFrames(r,g,b,a)
			end
		end
	end
end
---------------------------------------------------------
function ClassColor(unit,fNam)
	local playerClass, englishClass = UnitClass(unit)
	if (englishClass=="DRUID") then
		local r,g,b,a = 1.0, 0.49, 0.04, Colors.hp100.a
		fNam:SetTextColor(r,g,b,a)
	elseif (englishClass=="HUNTER") then
		local r,g,b,a = 0.67, 0.83, 0.45, Colors.hp100.a 
		fNam:SetTextColor(r,g,b,a)
	elseif (englishClass=="MAGE") then
		local r,g,b,a = 0.41, 0.8, 0.94, Colors.hp100.a 
		fNam:SetTextColor(r,g,b,a)
	elseif (englishClass=="PALADIN") then
		local r,g,b,a = 0.96, 0.55, 0.73, Colors.hp100.a 
		fNam:SetTextColor(r,g,b,a)
	elseif (englishClass=="PRIEST") then
		local r,g,b,a = 1.0, 1.0, 1.0, Colors.hp100.a
		fNam:SetTextColor(r,g,b,a)
	elseif (englishClass=="ROGUE") then
		local r,g,b,a = 1.0, 0.96, 0.41, Colors.hp100.a 
		fNam:SetTextColor(r,g,b,a)
	elseif (englishClass=="SHAMAN") then
		local r,g,b,a = 0, 0.86, 0.73, Colors.hp100.a 
		fNam:SetTextColor(r,g,b,a)
	elseif (englishClass=="WARLOCK") then
		local r,g,b,a = 0.58, 0.51, 0.79, Colors.hp100.a 
		fNam:SetTextColor(r,g,b,a)
	elseif (englishClass=="WARRIOR") then
		local r,g,b,a = 0.78, 0.61, 0.43, Colors.hp100.a 
		fNam:SetTextColor(r,g,b,a)
	end
end
---------------------------------------------------------
function FrameStopFlashing(tBar,tBG)
	if UIFrameIsFlashing(tBar) then
		UIFrameFlashRemoveFrame(tBar)	
	elseif UIFrameIsFlashing(tBG) then
		UIFrameFlashRemoveFrame(tBG)
	end
end
---------------------------------------------------------
function ShowAfterFlash(tBar,tBG,tBG2)
	if (tBar:IsVisible()==nil) then
		tBar:Show()
	--	DEFAULT_CHAT_FRAME:AddMessage("tBar false")
	elseif (tBG:IsVisible()==nil) then
		tBG:Show()
	--	DEFAULT_CHAT_FRAME:AddMessage("tBG false")
	elseif (tBG2:IsVisible()==nil) then
		tBG2:Show()
	--	DEFAULT_CHAT_FRAME:AddMessage("tBG2 false")
	end
end
---------------------------------------------------------
function ColorFrames(r,g,b,a)
	tBar:SetVertexColor(r,g,b,a)
	tBG:SetVertexColor(r,g,b,a)
	fPer:SetTextColor(r,g,b,a)
	fDef:SetTextColor(r,g,b,a)
end
---------------------------------------------------------
function ColorFadeFrames(r,g,b)
	tBar:SetVertexColor(r,g,b)
	tBG:SetVertexColor(r,g,b)
	fPer:SetTextColor(r,g,b)
	fDef:SetTextColor(r,g,b)
end
---------------------------------------------------------
function PartyFrameScale(tBG,tBG2,fBG,fBut)
	if (InCombatLockdown()==nil) then
		if UnitExists("party1") 
		and (not UnitExists("party2"))
		and (not UnitExists("party3"))
		and (not UnitExists("party4")) then
			local height = Options.frame.bg.height
			tBG:SetHeight(height)
			tBG2:SetHeight(height-2)
			fBG:SetHeight(height)
			fBut:SetHeight(height)
		elseif UnitExists("party1") 
		and  UnitExists("party2")
		and (not UnitExists("party3"))
		and (not UnitExists("party4")) then
			local height = ((Options.frame.bg.height/2)-3)
			tBG:SetHeight(height)
			tBG2:SetHeight(height-2)
			fBG:SetHeight(height)
			fBut:SetHeight(height)
		elseif UnitExists("party1") 
		and  UnitExists("party2")
		and  UnitExists("party3")
		and (not UnitExists("party4")) then
			local height = ((Options.frame.bg.height/3)-3)
			tBG:SetHeight(height)
			tBG2:SetHeight(height-2)
			fBG:SetHeight(height)
			fBut:SetHeight(height)
		elseif UnitExists("party1") 
		and  UnitExists("party2")
		and  UnitExists("party3")
		and  UnitExists("party4") then
			local height = ((Options.frame.bg.height/4)-3)
			tBG:SetHeight(height)
			tBG2:SetHeight(height-2)
			fBG:SetHeight(height)
			fBut:SetHeight(height)
		end
	end
end
---------------------------------------------------------
function PartyBarScale(fBar,max,cur)
--if (InCombatLockdown()==nil) then
	if UnitExists("party1") 
	and (not UnitExists("party2"))
	and (not UnitExists("party3"))
	and (not UnitExists("party4")) then
		local height = (Options.frame.bg.height-3)
		if (cur==0) then
			fBar:SetHeight(1)
		else
			if (max>=cur) then
				fBar:SetHeight(height/max*cur)
			else 
				fBar:SetHeight(height)
			end
		end
	elseif UnitExists("party1") 
	and UnitExists("party2")
	and (not UnitExists("party3"))
	and (not UnitExists("party4")) then
		local height = ((Options.frame.bg.height/2)-3)
		if (cur==0) then
			fBar:SetHeight(1)
		else
			if (max>=cur) then
				fBar:SetHeight(height/max*cur)
			else 
				fBar:SetHeight(height)
			end
		end
	elseif UnitExists("party1") 
	and UnitExists("party2")
	and UnitExists("party3")
	and (not UnitExists("party4")) then
		local height = ((Options.frame.bg.height/3)-3)
		if (cur==0) then
			fBar:SetHeight(1)
		else
			if (max>=cur) then
				fBar:SetHeight(height/max*cur)
			else 
				fBar:SetHeight(height)
			end
		end	
	elseif UnitExists("party1") 
	and UnitExists("party2")
	and UnitExists("party3")
	and UnitExists("party4") then
		local height = ((Options.frame.bg.height/4)-3)
		if (cur==0) then
			fBar:SetHeight(1)
		else
			if (max>=cur) then
				fBar:SetHeight(height/max*cur)
			else 
				fBar:SetHeight(height)
			end
		end
	end
--end
end
---------------------------------------------------------
function FrameFade(unit,deficit,a,tBar,tBG,tBG2)
	if (UnitPowerType(unit)==0) then
		if (deficit == 0) then			
			if ((tBG:GetAlpha()==a) 
			or (tBar:GetAlpha()==a) 
			or (tBG2:GetAlpha()==a))
			and (UnitAffectingCombat(unit)==nil) then
			--	DEFAULT_CHAT_FRAME:AddMessage("combat reset1")
				UIFrameFadeOut(tBar, Options.fade.outTime, a, Options.fade.alpha)
				UIFrameFadeOut(tBG,  Options.fade.outTime, a, Options.fade.alpha)
				UIFrameFadeOut(tBG2, Options.fade.outTime, a, Options.fade.alpha)
			
			elseif ((tBG:GetAlpha()<=Options.fade.alpha) 
			or (tBar:GetAlpha()<=Options.fade.alpha) 
			or (tBG2:GetAlpha()<=Options.fade.alpha))
			and (UnitAffectingCombat(unit)==1) then
			--	DEFAULT_CHAT_FRAME:AddMessage("combat reset2")
				UIFrameFadeIn(tBar, Options.fade.inTime, Options.fade.alpha, a)
				UIFrameFadeIn(tBG,  Options.fade.inTime, Options.fade.alpha, a)
				UIFrameFadeIn(tBG2, Options.fade.inTime, Options.fade.alpha, a)
			end
		---[[
		elseif (deficit ~= 0) then	
			if ((tBG:GetAlpha()<=Options.fade.alpha) 
			or (tBar:GetAlpha()<=Options.fade.alpha) 
			or (tBG2:GetAlpha()<=Options.fade.alpha)) then
			--	DEFAULT_CHAT_FRAME:AddMessage("combat reset3")
				UIFrameFadeIn(tBar, Options.fade.inTime, Options.fade.alpha, a)
				UIFrameFadeIn(tBG,  Options.fade.inTime, Options.fade.alpha, a)
				UIFrameFadeIn(tBG2, Options.fade.inTime, Options.fade.alpha, a)
			end
		--]]
		end
		
	elseif (UnitPowerType(unit)~=0) then
		local def = (1-(UnitHealth(unit)/UnitHealthMax(unit)))
		if (def == 0) then
			if ((tBG:GetAlpha()==a) 
			or (tBar:GetAlpha()==a) 
			or (tBG2:GetAlpha()==a))
			and (UnitAffectingCombat(unit)==nil) then
			--	DEFAULT_CHAT_FRAME:AddMessage("combat reset1")
				UIFrameFadeOut(tBar, Options.fade.outTime, a, Options.fade.alpha)
				UIFrameFadeOut(tBG,  Options.fade.outTime, a, Options.fade.alpha)
				UIFrameFadeOut(tBG2, Options.fade.outTime, a, Options.fade.alpha)
			
			elseif ((tBG:GetAlpha()<=Options.fade.alpha) 
			or (tBar:GetAlpha()<=Options.fade.alpha) 
			or (tBG2:GetAlpha()<=Options.fade.alpha))
			and (UnitAffectingCombat(unit)==1) then
			--	DEFAULT_CHAT_FRAME:AddMessage("combat reset2")
				UIFrameFadeIn(tBar, Options.fade.inTime, Options.fade.alpha, a)
				UIFrameFadeIn(tBG,  Options.fade.inTime, Options.fade.alpha, a)
				UIFrameFadeIn(tBG2, Options.fade.inTime, Options.fade.alpha, a)
			end
		---[[
		elseif (def ~= 0) then	
			if ((tBG:GetAlpha()<=Options.fade.alpha) 
			or (tBar:GetAlpha()<=Options.fade.alpha) 
			or (tBG2:GetAlpha()<=Options.fade.alpha)) then
			--	DEFAULT_CHAT_FRAME:AddMessage("combat reset3")
				UIFrameFadeIn(tBar, Options.fade.inTime, Options.fade.alpha, a)
				UIFrameFadeIn(tBG,  Options.fade.inTime, Options.fade.alpha, a)
				UIFrameFadeIn(tBG2, Options.fade.inTime, Options.fade.alpha, a)
			end
		--]]
		end
	end
end
---------------------------------------------------------
function DisableFrame(fBG,fBut)
	fBG:SetAlpha(0)
	fBG:EnableMouse(false)
	fBut:EnableMouse(false)
end
---------------------------------------------------------
function HealthNameParty(unit,fNam)
	if (Options.name.party==1) then
		ClassColor(unit,fNam)
		fNam:SetText(string.sub(UnitName(unit), 1, Options.name.format.party)) 
	else
		fNam:SetText()
	end
end
---------------------------------------------------------
function HealthDeficitParty(cur,max,fDef,deficit)
	if (cur/max)>Options.deficit.party.Max
	or (cur/max)<Options.deficit.party.Min then
		fDef:Hide() 
	else
		fDef:Show()
		--defmode deficit
		if (Options.deficit.mode==1) then
			if (Options.deficit.format==0) then
				fDef:SetText("-" ..deficit)
			elseif (Options.deficit.format==1) then		
				fDef:SetText(string.format("-%.1f", (deficit/1000)))
			end
			--defmode current
		elseif (Options.deficit.mode==0) then
			if (Options.deficit.format==0) then
				fDef:SetText(cur)
			elseif (Options.deficit.format==1) then		
				fDef:SetText(string.format("%.1f", (cur/1000)))
			end
		end
	end
end
---------------------------------------------------------
function ManaDeficitParty(unit,cur,max,fDef,deficit)
	if (cur/max)>Options.deficit.party.Max
	or (cur/max)<Options.deficit.party.Min then 
		fDef:Hide()
	else
		if (UnitPowerType(unit)==0) then
			fDef:Show()
			--defmode deficit
			if (Options.deficit.mode==1) then
				if (Options.deficit.format==0) then
					fDef:SetText("-" ..deficit)
				elseif (Options.deficit.format==1) then		
					fDef:SetText(string.format("-%.1f", (deficit/1000)))
				end
			--defmode current
			elseif (Options.deficit.mode==0) then
				if (Options.deficit.format==0) then
					fDef:SetText(UnitMana(unit))
				elseif (Options.deficit.format==1) then		
					fDef:SetText(string.format("%.1f", (cur/1000)))
				end
			end
		elseif (UnitPowerType(unit)==1)
		or (UnitPowerType(unit)==2)
		or (UnitPowerType(unit)==3) then
			fDef:Show()
			fDef:SetText(cur)
		end
	end
end
---------------------------------------------------------
function UnitSelected(unit,fBut)
	if (UnitIsUnit(unit,"target")==1)  then
	--	DEFAULT_CHAT_FRAME:AddMessage("true")
		fBut:LockHighlight()
	elseif (UnitIsUnit(unit,"target")==nil) then
	--	DEFAULT_CHAT_FRAME:AddMessage("false")
		fBut:UnlockHighlight()
	end
end
---------------------------------------------------------
--[[			
function MyFrame:OnUpdate()  
	-- Some code  
	if self:GetScale() ~= x then  
		self:DoScaling(x);  
	end  
	-- More code  
end  
	  
function MyFrame:DoScaling(x)  
	if ~InCombatLockdown() then  
		self:SetScale(x)  
	end  
end 
--]]
